﻿using NUnit.Framework;
using NUnit.Framework.SyntaxHelpers;

namespace RomanNumeralsCodingDojo
{
    [TestFixture]
    public class RomanNumeralsTest
    {
        [Test]
        public void Should_parse_I_to_X()
        {
            AssertParse("I", 1);
            AssertParse("II", 2);
            AssertParse("III", 3);
            AssertParse("IV", 4);
            AssertParse("V", 5);
            AssertParse("VI", 6);
            AssertParse("VII", 7);
            AssertParse("VIII", 8);
            AssertParse("IX", 9);
            AssertParse("X", 10);
        }

        [Test]
        public void Should_parse_XI_to_XX()
        {
            AssertParse("XI", 11);
            AssertParse("XII", 12);
            AssertParse("XIII", 13);
            AssertParse("XIV", 14);
            AssertParse("XV", 15);
            AssertParse("XVI", 16);
            AssertParse("XVII", 17);
            AssertParse("XVIII", 18);
            AssertParse("XIX", 19);
            AssertParse("XX", 20);
        }

        [Test]
        public void Should_parse_XX_to_LXXX()
        {
            AssertParse("XXX", 30);
            AssertParse("XL", 40);
            AssertParse("XLIV", 44);
            AssertParse("L", 50);
            AssertParse("LX", 60);
            AssertParse("LXX", 70);
            AssertParse("LXXIX", 79);
            AssertParse("LXXX", 80);
        }

        [Test]
        public void Should_parse_XC_to_DC()
        {
            AssertParse("XC", 90);
            AssertParse("C", 100);
            AssertParse("CD", 400);
            AssertParse("D", 500);
            AssertParse("DC", 600);

        }

        [Test]
        public void Should_parse_M()
        {
            AssertParse("M", 1000);
        }

        [Test]
        public void Should_parse_MCMXCIX()
        {
            AssertParse("MCMXCIX", 1999);
        }


        private static void AssertParse(string romanNumeral, long expectedValue)
        {
            Assert.That(new RomanNumerals(romanNumeral).Value, Is.EqualTo(expectedValue));
        }
    }
}
